#include <QAxWidget>
#include <QLibraryInfo>
#include <QSysInfo>
#include <QApplication>
#include <QDesktopWidget>
#include "vcgantt.h"
#include <ocidl.h>
#include <QDebug>
#include <QTimer>
#include <QStringList>
#include <QMouseEvent>
#include <QUuid>
#ifdef QT_DIAG_LIB
#  include <eventfilter.h>
#  include <qwindowdump.h>
#  include <qwidgetdump.h>
#  include <nativewindowdump.h>
#endif

/* type lib id: {A4E79A23-C9E1-11CF-BDD7-02608C4302A9}
 * dumpcpp -getfile {A4E79A23-C9E1-11CF-BDD7-02608C4302A9}
 * To generate ggant.cpp/.h
 * dumpcpp -o gant {A4E79A23-C9E1-11CF-BDD7-02608C4302A9}
 */

bool optNativeWins = false;

class GantWidget : public VcGanttLib::VcGantt {
   Q_OBJECT
public:

public slots:
    void dump();

protected:
    void keyPressEvent(QKeyEvent *e) override
    { qDebug() << __FUNCTION__ << e; }
    void mousePressEvent(QMouseEvent *e) override
    { qDebug() << __FUNCTION__ << e; }
};

void GantWidget::dump()
{
#ifdef QT_DIAG_LIB
    qDebug() << '\n';
    QtDiag::dumpAllWidgets();
    QtDiag::dumpAllWindows();
    if (optNativeWins)
        QtDiag::dumpNativeQtTopLevels();
    qDebug() << "GetFocus=" << GetFocus();
#endif
}

int main(int argc, char **argv)
{
    QApplication a(argc, argv);
    QStringList args = QCoreApplication::arguments();
    args.pop_front();

#ifdef QT_DIAG_LIB
    if (args.contains("-e")) {
        QtDiag::EventFilter::EventCategories cats = QtDiag::EventFilter::KeyEvents
                | QtDiag::EventFilter::MouseEvents;
        QtDiag::EventFilter *ef =  new QtDiag::EventFilter(cats);
        a.installEventFilter(ef);
    }
#endif


    GantWidget gantWidget;
    const QRect ag = QApplication::desktop()->availableGeometry(&gantWidget);
    gantWidget.resize(ag.width() * 2 / 3, ag.height() / 2);
    gantWidget.move(ag.topLeft() + QPoint((ag.width() - gantWidget.width()) /2 , 100));


    qDebug() <<  QT_VERSION_STR << args
#if QT_VERSION >= 0x050000
             << '\n' << QLibraryInfo::build()
#endif
             << "\nword size" << QSysInfo::WordSize << '\n';

    optNativeWins = args.contains("-a");

    gantWidget.setWindowTitle(QT_VERSION_STR);    
    gantWidget.show();

    if (args.contains("-t")) {
        QTimer  *tm  =new QTimer(&gantWidget);
        QObject::connect(tm, &QTimer::timeout, &gantWidget, &GantWidget::dump);
        tm->start(2000);
    }

    return a.exec();
}

#include "main.moc"
